import 'package:base_repository/base_repository.dart';
import 'package:xiaoxiong_repository/repository/user_repository.dart';

class UserRepositoryImpl extends UserRepository {
  UserRepositoryImpl.get();
  static final UserRepositoryImpl _instance = UserRepositoryImpl.get();
  factory UserRepositoryImpl() {
    return _instance;
  }
  @override
  Future<DSResponseObject> qryUserInfo({int dataType = 0}) async {
    dynamic result = await DSDioUtil.getInstance().get(
      '/user.info',
      queryParameters: {
        'dataType': dataType,
      },
    );
    DSResponseObject object = DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
    return object;
  }
  
  ///
  /// 判断用户是否签到
  ///
  @override
  Future<DSResponseObject> isUserSign() async {
    dynamic result = await DSDioUtil.getInstance().post(
      '/sign.isSign',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }

  @override
  Future<DSResponseObject> userSign() async {
    dynamic result = await DSDioUtil.getInstance().post(
      '/sign.userSign',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }

  ///
  /// 获取签到幸运点
  ///
  @override
  Future<DSResponseObject> getSignLucky() async {
    dynamic result = await DSDioUtil.getInstance().get(
      '/sign.getLuckyNew',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }

  @override
  Future<DSResponseObject> watchVideoRewardScore() async {
    dynamic result = await DSDioUtil.getInstance().post(
      '/video.watchVideoRewardScore',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }

  @override
  Future<DSResponseObject> videoGetVideoInfo() async {
    dynamic result = await DSDioUtil.getInstance().get(
      '/video.getVideoInfo',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }

  ///
  /// 积分兑换初始化
  ///
  @override
  Future<DSResponseObject> signConvertInData() async {
    dynamic result = await DSDioUtil.getInstance().get(
      '/sign.convertInData',
    );
    return DSResponseObject.fromJson(
      result,
      (data) => Map<String, dynamic>.from(data!),
    );
  }
}
