import 'package:base_repository/base_repository.dart';
import 'impl/product_repository_impl.dart';

///
/// ProductRepository
/// 商品相关的网络库
///
abstract class ProductRepository {
  static ProductRepository get() {
    return ProductRepositoryImpl();
  }

  ///
  /// 捡漏神单榜
  /// [page]            第N页
  /// [type]            类型：1.精选专区；2. 9.9专区；3. 6.9专区；4. 3.9专区
  ///
  Future<DSResponseList> getNines({
    int page = 1,
    int pagesize = 10,
    required int type,
  });

  ///
  /// 兑换免单商品
  /// [id]          商品数据id，不是商品id
  /// [needUrl]     是否需要跳链  1需要   0不需要
  ///
  Future<DSResponseObject> qryGoFreeBuy({
    required String id,
    required int needUrl,
  });

  ///
  /// 获取免单获取跳转链接
  ///
  Future<DSResponseObject> qryFreeShareInfo();

  ///
  /// 兑换免单商品结果
  /// [id]                数据id
  ///
  Future<DSResponseObject> qryFreeProductResult({required String id});
}
